function showDialog(title, innerControl, okCallback, cancelCallback)
{
    var dialogOverlay = $('<div>');
    dialogOverlay.attr({'class': 'dialogOverlay', 'id': 'aOverlay'});
    $('body').append(dialogOverlay);
    
    var dialogOuter = $('<div>');
    dialogOuter.attr({'class': 'dialogOuter'});
    dialogOverlay.append(dialogOuter);
    dialogOuter.append(title);
    
    if (innerControl != null)
    {
        var innerControlBox = $('<div>');
        dialogOuter.append(innerControlBox);
        innerControlBox.append(innerControl);
    }
    
    dialogOverlay.fadeIn(0);
    
    var buttonPanel = $('<div>');
    buttonPanel.attr({'class': 'aButtonsPanel'});
    dialogOuter.append(buttonPanel);
    
    var keydownHandler = function(e)
    {
        if(dialogOverlay.is(':visible'))
        {
            if(e.keyCode == 13)
            {
                if (okCallback)
                {
                    dialogOverlay.remove();
                    $(document).unbind('keydown', keydownHandler);
                    okCallback();
                }
            }
            if(e.keyCode == 27)
            {
                if (cancelCallback)
                {
                    dialogOverlay.remove();
                    $(document).unbind('keydown', keydownHandler);
                    cancelCallback();
                }
            }
        }
    };
    
    $(document).keydown(keydownHandler);
    
    var completeDialogCallback = function(){dialogOverlay.remove();$(document).unbind('keydown', keydownHandler);};
    
    if (okCallback != null)
    {
        var okButton = $('<button>');
        okButton.attr({'class': 'aButtons'});
        okButton.append('OK');
        buttonPanel.append(okButton);
        okButton.click(function(){completeDialogCallback();okCallback();});
    }
    
    if (cancelCallback != null)
    {
        var cancelButton = $('<button>');
        cancelButton.append(cancelButtonTitle);
        cancelButton.attr({'class': 'aButtons'});
        buttonPanel.append(cancelButton);
        cancelButton.click(function(){completeDialogCallback();cancelCallback();});
    }
    
    return completeDialogCallback;
}

function inputStringDialog(title, defaultValue, callback)
{
    var textBoxInput = $('<input>');
    textBoxInput.attr({'class': 'aTextbox', 'type': 'text', 'value': defaultValue ? defaultValue : ''});
    
    var okCallback = function(){callback(true, textBoxInput.val());};
    var cancelCallback = function(){callback(false, '');};
    
    showDialog(title, textBoxInput, okCallback, cancelCallback);
    
    textBoxInput.focus();
}

function messageDialog(message, callback)
{
    var okCallback = function(){callback();};
    showDialog(message, null, okCallback, null);
}

function confirmDialog(title, callback)
{
    var okCallback = function(){callback(true);};
    var cancelCallback = function(){callback(false);};
    
    showDialog(title, null, okCallback, cancelCallback);
}

function progressDialog(title, callback)
{
    var cancelCallback = function(){callback(false);};
    
    var progressBar = $('<progress>');
    progressBar.attr({'class': 'aProgressBar', 'value': 0, 'max': 0});
    
    var completeDialogCallback = showDialog(title, progressBar, null, cancelCallback);
    
    var controlLambda = function(complete, value, max)
    {
        if (complete)
        {
            completeDialogCallback();
            callback(true);
        }
        else
            progressBar.attr({'class': 'aProgressBar', 'value': value, 'max': max});
    }
    
    return controlLambda;
}
